// naumann@stce.rwth-aachen.de

#pragma once

#include<iostream>

template<typename T>
class list {

  int l;
  struct list_element {
    T data;
    list_element* next;
    list_element(const T&);
  } *first;

  void free(const list_element *);
public:
  list(int);
  ~list();
  int length() const ;
  void erase(int);
  void insert(int, const T&);
  void set(int, const T&);
  const T& get(int) const;
  void to_dot(const char*) const;
};

#include "list.cpp"
