// naumann@stce.rwth-aachen.de

#include <iostream>

struct l {

  struct le { 
    int i=0;
    le *prev=nullptr,*next=nullptr; 
    le()=default;
    le(int i) : i(i) {}
  } first,*last=&first;

  l(int n) {
    for (int i=1;i<n;i++) {
      last->next=new le(i);
      last->next->prev=last;
      last=last->next;
    }
  }
  
  /*
  // pre-order
  void forward(const le* e) {
    std::cout << e << std::endl; 
    if (e->next) forward(e->next);
  }
  void forward() { forward(&first); }

  void backward(const le* e) {
    std::cout << e << std::endl; 
    if (e->prev) backward(e->prev);
  }
  void backward() { backward(last); }
  */

  // post-order
  void backward(const le* e) {
    if (e->next) backward(e->next);
    std::cout << e << std::endl; 
  }
  void backward() { backward(&first); }

  void forward(const le* e) {
    if (e->prev) forward(e->prev);
    std::cout << e << std::endl; 
  }
  void forward() { forward(last); }
};

int main() {
  l x(3); 
  x.forward(); 
  x.backward();
  return 0;
}
