// naumann@stce.rwth-aachen.de

#pragma once 

#include <cstdlib>

template<typename T>
class vector {
  T* v; size_t n;
  void grow();
  void shrink();
 public:
  vector(size_t, const T&);
  ~vector();
  void insert(const T&, size_t);
  void erase(size_t);
  void print() const;
};

#include<vector.cpp>
