#include <iostream>
#include <list>
#include <algorithm>

class A { 
  size_t i; 
public:
  A(size_t i) : i(i) {};
  size_t id() const { return i; }
};

std::ostream& operator<<(std::ostream& o, const A& a) {
  o << a.id(); return o;
}

int main() {
  using namespace std;
  A a(1),b(2),c(3); list<A> l; 
  l.push_back(a);
  l.push_back(b);
  l.push_back(c);
  std::cout << "min: " << *min_element(l.begin(),l.end()) << std::endl;
  std::cout << "max: " << *max_element(l.begin(),l.end()) << std::endl;
  return 0;
}
